#ifndef	_INIT_MATCH_H_
#define	_INIT_MATCH_H_

// б
#define	MISMATCH	-1e30

// ե륿ݤΦ
#define	SIGMA		2

// ҥȥ
#define	HISTMAX		255

// Harris ڥ졼Υѥ᡼
#define	H_Ns		3
#define	H_sg		1
#define	H_rk		0.04
#define	H_s		0.0
#define	H_mindist	8

#include	"CImage.h"
#include	"Mat.h"
#include	"grouping.h"
#include	"Corresp_cls.h"

// ɸФΥ
void	sort_index_pair(Mat &Jab, IndexPair idx[], int N);

// ǥκȥѥ
int	make_index(Mat &Jab, int Na, int Nb, IndexPair idx[], double x[]);

// ǥκȥѥ
int	make_index2(Mat &Jab, Mat &lambda,
		    int Na, int Nb, IndexPair idx[], double x[],
		    int *NNa, int *NNb);

// Jab ƥå
void	recheck_table(Mat& Jab, Mat& lambda, int Na, int Nb);

// ĺΥҥȥ
double	make_hist(Mat &Jab, int nmax);

// бӽ
int	delete_mismatch(Mat &Jab, IndexPair idx[], int grp[], int N);

// бγ
int	fix_corresp(Mat& Jab, int Na, int Nb, int N,
		    IndexPair idx0[], IndexPair idx[]);

// бФι¤ΤؤѴ
void	corresp_pairs(Point pa[], Point pb[],
		      IndexPair idx[], int Nm, Corresp cp[]);

// ưб׻
int	init_matching(Image& Ima, Image& Imb,
		      Mat& Jab, Point **pa, Point **pb,
		      int* Na, int* Nb,
		      Corresp** croot, int* N,
		      int Pmax, int t_size,
		      double pc, int ImpHrsFlg);

#endif	//	_INIT_MATCH_H_
