#ifndef	_REMATCH_H_
#define	_REMATCH_H_

#include "grouping.h"
#include "init_match.h"

// ¿ʤκб
int	rematch_tr(Mat& Jab0, Point pa[], Point pb[],
		   int width, int height, double fl, 
		   VecC& Tm, double Sm, double pc,
		   Corresp **cp0, int* N0);

// Ѵκб
int	rematch_sim(Image& Ima, Image& Imb,
		    Mat& Jab0, Point pa[], Point pb[],
		    int width, int height, double fl, 
		    double scale, Mat& R, VecC& t, double Sm,
		    int tsize, double pc,
		      Corresp **cp0, int* N0);

// եѴκб
int	rematch_aff(Image& Ima, Image& Imb,
		    Mat& Jab0, Point pa[], Point pb[],
		    int width, int height, double fl, 
		    Mat& Ac, Mat& Wc, double Sm,
		    int tsize, double pc,
		    Corresp **cp0, int* N0);

// ͱѴκб
int	rematch_homo(Image& Ima, Image& Imb,
		     Mat& Jab0, Point pa[], Point pb[],
		     int width, int height, double fl, 
		     Mat& Hm, double dthd, int tsize,
		     Corresp **cp0, int* N0);

#endif	//	_REMATCH_H_
