//
// ƥץ졼ȥޥå󥰤ˤбõ
// :ּͱѴμư׻(3)
//	2001ǯ312
//	4. бκб
//
//	IndexPair, Point κ

#include	"CImage.h"

#include	"Corresp_cls.h"
#include	"grouping.h"
#include	"init_match.h"
#include	"rematch.h"

// 
static double
sqr(double x)
{
   return x * x;
}

// ɸѴ
static VecC
convert_vec2(Point cp, int width, int height)
{
   VecC	X(2);
   int	w2 = width / 2;
   int	h2 = height / 2;

   w2 = width / 2;
   h2 = height / 2;
   X[0] = (double)(h2 - cp.v);
   X[1] = (double)(cp.u - w2);

   return X;
}

// Ѵбλĺ
static double
calc_J_lambda_sim(double s, Mat& R, VecC& t,
		  VecC& Xa, VecC& Xb)
{
   VecC		tmp(2);
   double	d;

   tmp = Xb - s * R * Xa - t;
   d = tmp.sqnorm();

   return (d / (1.0 + s * s));
}

// 17x17 Υƥץ졼Ⱥ
static void
get_template(Image& Im, Point& p, IntTemplate& Tp)
{
   int		d;
   int		x0, y0;
   
   x0 = Im.height() / 2 - p.v;
   y0 = p.u - Im.width() / 2;

   for (int y = Tp.ymin(); y <= Tp.ymax(); y++)
      for (int x = Tp.xmin(); x <= Tp.xmax(); x++)
      {
	 d = Im.get_pixel2(x0 + x, y0 + y);
	 Tp.put_pixel(x, y, d);
      }
}

// ƥץ졼(1)2ħޤΰȤ
// ƥץ졼ȥޥå
static double
sim_tp_matching(IntTemplate& Ta, Image& Imb, Point& pb,
		 double scale, Mat& R)
{
   double	s, b, d;
   int		sx, sy, ex, ey, xb, yb;
   double	xp, yp;
   double	r11, r12, r21, r22;

   sx = Ta.xmin();
   ex = Ta.xmax();
   sy = Ta.ymin();
   ey = Ta.ymax();

   xb = Imb.height() / 2 - pb.v;
   yb = pb.u - Imb.width() / 2;

   r11 = R[0][0];
   r12 = R[0][1];
   r21 = R[1][0];
   r22 = R[1][1];
   
   s = 0.0;
   for (int y = sy; y <= ey; y++)
      for (int x = sx; x <= ex; x++)
      {
	 xp = xb + scale * (r11 * x + r12 * y);
	 yp = yb + scale * (r21 * x + r22 * y);

	 b = Imb.get_cpixel(xp, yp);
	 if (b < 0)	// ϰϳ
	    return MISMATCH;
	 d = Ta.get_pixel(x, y);
	 s += sqr(b - d);
      }
   return s;
}

// Jab ΥåȺƷ׻
static void
recalc_table(Mat& Jab, Mat& lambda,
	     Image& Ima, Image& Imb,
	     Point pa[], Point pb[], int Na, int Nb,
	     int width, int height, int tsize,
	     Mat& R, VecC& t, double scale, double Sm)
{
   IntTemplate	Ta(tsize,tsize);	//  9x9  17x17 Υƥץ졼
   VecC		Xa(2), Xb(2);
   double	Jl;

   // 7*SmʲͭȤ롥
   for (int a = 0; a < Na; a++)
   {
      Xa = convert_vec2(pa[a], width, height);
      get_template(Ima, pa[a], Ta);
      for (int b = 0; b < Nb; b++)
      {
	 Jab[a][b] = sim_tp_matching(Ta, Imb, pb[b], scale, R);
	 Xb = convert_vec2(pb[b], width, height);
	 Jl = calc_J_lambda_sim(scale, R, t, Xa, Xb);
	 if (Jl < (7.0 * Sm))
	    lambda[a][b] = 1.0;
	 else
	    lambda[a][b] = MISMATCH;
      }
   }
}

// Ѵκб
int
rematch_sim(Image& Ima, Image& Imb,
	    Mat& Jab, Point pa[], Point pb[],
	    int width, int height, double fl, 
	    double scale, Mat& R, VecC& t, double Sm,
	    int tsize, double pc,
	    Corresp **cp0, int* N0)
// Jab0[][] ϺǽΥޥå󥰤κݤΤ
{
   int		Na, Nb, NNa, NNb, L;
   IndexPair	*idx, *idx0;
   double	*x;
   Corresp	*cp;
   int		*grp;
   int		N, Nm;
   int		thd;

   // 줾βħθĿμ
   Na = Jab.row();
   Nb = Jab.col();
   Mat	lambda(Jab.row(),Jab.col());

   // Jab κƷ׻ȥå
   recalc_table(Jab, lambda, Ima, Imb, pa, pb, Na, Nb,
		width, height, tsize, R, t, scale, Sm);

   N = Na * Nb;
   idx = new IndexPair [N];	// ǥ
   grp = new int [N];		// 롼
   x = new double [N];		// ѥ
   Mat	Jab0(Jab);		// Jab Υԡ

   // ǥ
   N = make_index2(Jab0, lambda, Na, Nb, idx, x, &NNa, &NNb);

   // Jab ƥå
   recheck_table(Jab0, lambda, Na, Nb);

   // 롼ԥ
   L = (NNa < NNb)? NNa: NNb;
   thd = grouping(x, grp, L, N, pc, HISTMAX);
   idx0 = new IndexPair [L];	// ǥ

   // бκ
   delete_mismatch(Jab0, idx, grp, N);

   // 
   sort_index_pair(Jab0, idx, N);

   // бγ
   Nm = fix_corresp(Jab0, Na, Nb, N, idx0, idx);

   // бФι¤ΤؤѴ
   cp = (*cp0) = new Corresp [Nm];
   corresp_pairs(pa, pb, idx0, Nm, cp);

   delete [] idx0;
   delete [] idx;
   delete [] x;
   
   return (*N0 = Nm);
}
