#ifndef _ADDRECIPES_H_
#define _ADDRECIPES_H_

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

#ifndef	TINY
#define	TINY	1.0e-20
#endif

#include <stdio.h>
#include <math.h>

#include "nrutil.h"
#include "nr.h"

// ؿ

double	rc_det(double **a, int n);
void	rc_inverse(double **a, double **y, int n);
void	rc_generic_inverse(double **a, double **y, int n, int m);
void	rc_gen_inv(double **a, double **y, int m, int n);
void	rc_trunc_gen_inv(double **a, double **y, int n, int m, int r);
void    rc_sle(double **a, double *b, int n);

// Ψʬ۴ؿ

double	chipdist(double chi2, int nu);	/* ʬ P */
double	chipdistr(double chi2, double nu);
double	chiqdist(double chi2, int nu);	/* ʬ Q */
double	chiqdistr(double chi2, double nu);
double	chiqinv(double q0, int nu);	/* ʬ Q ѡ */
double	chiqinvr(double q0, double nu);

double	fdist(double f, int n1, int n2);	/* Fʬ */
double	finv(double p0, int n1, int n2);	/* Fʬۤε */

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif /* _ADDRECIPES_H_ */
