//
// ƥץ졼ȥޥå󥰤ˤбõ
// :ּͱѴμư׻(3)
//	2001ǯ312
//	4. бκб
//
//	IndexPair, Point κ

#include	"CImage.h"

#include	"Corresp_cls.h"
#include	"grouping.h"
#include	"init_match.h"
#include	"rematch.h"

// 
static double
sqr(double x)
{
   return x * x;
}

// ɸѴ
static VecC
convert_vec(Point cp, int width, int height, double fl)
{
   VecC	X;
   int	w2 = width / 2;
   int	h2 = height / 2;

   w2 = width / 2;
   h2 = height / 2;
   X[0] = (double)(h2 - cp.v) / fl;
   X[1] = (double)(cp.u - w2) / fl;
   X[2] = 1.0;

   return X;
}

// եѴбλĺ
static double
calc_J_lambda_aff(Mat& A, Mat& W, VecC& Xa, VecC& Xb)
{
   VecC		T;
   double	d;

   T = Xb - A * Xa;
   d = (T , (W * T));

   return d;
}

// 25x25 Υƥץ졼Ⱥ
static void
get_template(Image& Im, Point& p, IntTemplate& Tp)
{
   int		d;
   int		x0, y0;
   
   x0 = Im.height() / 2 - p.v;
   y0 = p.u - Im.width() / 2;

   for (int y = Tp.ymin(); y <= Tp.ymax(); y++)
      for (int x = Tp.xmin(); x <= Tp.xmax(); x++)
      {
	 d = Im.get_pixel2(x0 + x, y0 + y);
	 Tp.put_pixel(x, y, d);
      }
}

// ƥץ졼(1)2ħޤΰȤ
// եƥץ졼ȥޥå
static double
aff_tp_matching(IntTemplate& Ta, Image& Imb, Point& pb, Mat& A)
{
   double	s, b, d;
   int		sx, sy, ex, ey, xb, yb;
   double	xp, yp;
   double	a11, a12, a21, a22;

   sx = Ta.xmin();
   ex = Ta.xmax();
   sy = Ta.ymin();
   ey = Ta.ymax();

   xb = Imb.height() / 2 - pb.v;
   yb = pb.u - Imb.width() / 2;
   
   a11 = A[0][0];
   a12 = A[0][1];
   a21 = A[1][0];
   a22 = A[1][1];

   s = 0.0;
   for (int y = sy; y <= ey; y++)
      for (int x = sx; x <= ex; x++)
      {
	 xp = xb + (a11 * x + a12 * y);
	 yp = yb + (a21 * x + a22 * y);

	 b = Imb.get_cpixel(xp, yp);
	 if (b < 0)	// ϰϳ
	    return MISMATCH;
	 d = Ta.get_pixel(x, y);
	 s += sqr(b - d);
      }
   return s;
}

// Jab ΥåȺƷ׻
static void
recalc_table(Mat& Jab, Mat& lambda,
	     Image& Ima, Image& Imb,
	     Point pa[], Point pb[], int Na, int Nb,
	     int width, int height, double fl, int tsize,
	     Mat& Ac, Mat& Wc, double Sm)
{
   IntTemplate	Ta(tsize,tsize);	//  9x9  25x25 Υƥץ졼
   VecC		Xa, Xb;
   double	Jl;

   // 7*SmʲͭȤ롥
   for (int a = 0; a < Na; a++)
   {
      Xa = convert_vec(pa[a], width, height, fl);
      get_template(Ima, pa[a], Ta);
      for (int b = 0; b < Nb; b++)
      {
	 Jab[a][b] = aff_tp_matching(Ta, Imb, pb[b], Ac);
	 Xb = convert_vec(pb[b], width, height, fl);
	 Jl = calc_J_lambda_aff(Ac, Wc, Xa, Xb);
	 if (Jl < (7.0 * Sm))
	    lambda[a][b] = 1.0;
	 else
	    lambda[a][b] = MISMATCH;
      }
   }
}

// եѴκб
int
rematch_aff(Image& Ima, Image& Imb,
	    Mat& Jab, Point pa[], Point pb[],
	    int width, int height, double fl, 
	    Mat& Ac, Mat& Wc, double Sm,
	    int tsize, double pc,
	    Corresp **cp0, int* N0)
// Jab0[][] ϺǽΥޥå󥰤κݤΤ
{
   int		Na, Nb, NNa, NNb, L;
   IndexPair	*idx, *idx0;
   double	*x;
   Corresp	*cp;
   int		*grp;
   int		N, Nm;
   int		thd;

   // 줾βħθĿμ
   Na = Jab.row();
   Nb = Jab.col();
   Mat	lambda(Jab.row(),Jab.col());

   // Jab κƷ׻ȥå
   recalc_table(Jab, lambda, Ima, Imb, pa, pb, Na, Nb, width, height, fl,
		tsize, Ac, Wc, Sm);

   N = Na * Nb;
   idx = new IndexPair [N];	// ǥ
   grp = new int [N];		// 롼
   x = new double [N];		// ѥ
   Mat	Jab0(Jab);		// Jab Υԡ

   // ǥ
   N = make_index2(Jab0, lambda, Na, Nb, idx, x, &NNa, &NNb);

   // Jab κƥå
   recheck_table(Jab0, lambda, Na, Nb);

   // 롼ԥ
   L = (NNa < NNb)? NNa: NNb;
   thd = grouping(x, grp, L, N, pc, HISTMAX);
   idx0 = new IndexPair [L];	// ǥ

   // бκ
   delete_mismatch(Jab0, idx, grp, N);

   // 
   sort_index_pair(Jab0, idx, N);

   // бγ
   Nm = fix_corresp(Jab0, Na, Nb, N, idx0, idx);

   // бФι¤ΤؤѴ
   cp = (*cp0) = new Corresp [Nm];
   corresp_pairs(pa, pb, idx0, Nm, cp);

   delete [] idx0;
   delete [] idx;
   delete [] x;
   
   return (*N0 = Nm);
}
